找回密码
 立即注册

QQ登录

只需一步,快速开始

扫一扫,访问微社区

查看: 800|回复: 1

[教学] 【AcGe几何库(四十二)】平面三曲线的公切圆(三切圆)

[复制链接]

已领礼包: 40个

财富等级: 招财进宝

发表于 2018-6-16 20:25:13 | 显示全部楼层 |阅读模式

马上注册,结交更多好友,享用更多功能,让你轻松玩转社区。

您需要 登录 才可以下载或查看,没有账号?立即注册

×
使用AcGeCircArc2d的set方法

AcGeCircArc2d &
set(
const AcGeCurve2d& curve1,
const AcGeCurve2d& curve2,
const AcGeCurve2d& curve3,
double& param1,
double& param2,
double& param3,
Adesk::Boolean& success);
curve1Input any 2D curve
curve2Input any 2D curve
curve3Input any 2D curve
param1Input parameter value on curve1 where arc touches curve
param2Input parameter value on curve2 where arc touches curve
param3Input parameter value on curve3 where arc touches curve
successOutput to indicate whether the arc was computed successfully
Changes the definition of the arc to be tangent to the three input curves. This function always returns a full circle. If this function returns a value for success that is Adesk::kFalse, then this function has not changed the object.

三曲线公切园.gif

  1. (defun c:tt ()
  2.   (while (and
  3.            (setq e1 (xdrx_entsel
  4.                       "\n拾取曲线1<退出>:"
  5.                       '((0 . "*LINE,ARC,CIRCLE,ELLIPSE"))
  6.                     )
  7.            )
  8.            (setq e2 (xdrx_entsel
  9.                       "\n拾取曲线2<退出>:"
  10.                       '((0 . "*LINE,ARC,CIRCLE,ELLIPSE"))
  11.                     )
  12.            )
  13.            (setq e3 (xdrx_entsel
  14.                       "\n拾取曲线3<退出>:"
  15.                       '((0 . "*LINE,ARC,CIRCLE,ELLIPSE"))
  16.                     )
  17.            )
  18.          )
  19.     (if        (and
  20.           (setq p1 (cadr e1))
  21.           (setq e1 (car e1))
  22.           (setq p2 (cadr e2))
  23.           (setq e2 (car e2))
  24.           (setq p3 (cadr e3))
  25.           (setq e3 (car e3))
  26.           (setq g1 (xdge::constructor e1)) ;构建曲线1几何对象
  27.           (setq g2 (xdge::constructor e2)) ;构建曲线2几何对象
  28.           (setq g3 (xdge::constructor e3)) ;构建曲线2几何对象
  29.           (setq pa1 (xdge::getpropertyvalue g1 "paramof" p1))
  30.                                         ;曲线1上拾取点的参数值
  31.           (setq pa2 (xdge::getpropertyvalue g2 "paramof" p2))
  32.                                         ;曲线2上拾取点的参数值
  33.           (setq pa3 (xdge::getpropertyvalue g3 "paramof" p3))
  34.                                         ;曲线2上拾取点的参数值
  35.           (setq g-1 (xdge::entity:3d->2d g1));3d几何对象转2d
  36.           (setq g-2 (xdge::entity:3d->2d g2));3d几何对象转2d
  37.           (setq g-3 (xdge::entity:3d->2d g3));3d几何对象转2d
  38.           (setq garc (xdge::constructor "kcircarc2d"))
  39.                                         ;构建AcGeCircArc2d对象
  40.           (xdge::setpropertyvalue garc "set" g-1 g-2 g-3 pa1 pa2 pa3)
  41.                                         ;set方法,成功修改garc到公切圆弧
  42.         )
  43.       (progn
  44.         (xdge::entity:make garc)        ;生成数据库圆弧实体
  45.         (xdrx_setpropertyvalue (entlast) "color" 2) ;设置颜色2
  46.       )
  47.     )
  48.     (xdge::free g1 g2 g3 g-1 g-2 g-3 garc)                ;释放创建的几何对象
  49.   )
  50.   (princ)
  51. )



论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!

已领礼包: 3904个

财富等级: 富可敌国

发表于 2018-6-17 08:42:36 | 显示全部楼层
好像比较难呀
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
回复 支持 反对

使用道具 举报

您需要登录后才可以回帖 登录 | 立即注册

本版积分规则

QQ|申请友链|Archiver|手机版|小黑屋|辽公网安备|晓东CAD家园 ( 辽ICP备15016793号 )

GMT+8, 2024-11-22 00:51 , Processed in 0.283457 second(s), 34 queries , Gzip On.

Powered by Discuz! X3.5

© 2001-2024 Discuz! Team.

快速回复 返回顶部 返回列表